/*
;*****************************************************************************************************
;*    							Copyright (c) 2006 by JiaoJinXing. 
;*									   All rights reserved.
;*
;*---- ļϢ --------------------------------------------------------------------------------------
;*        : RS232.c
;*        : 
;*          : ļ
;*
;*---- ʷ汾Ϣ ----------------------------------------------------------------------------------
;* ա		  : 2008 7  8 
;* 		  : 
;* 衡		  : 汾 V1.0.0
;*
;* ա		  : 2009 1  30 
;* 		  : 
;* 衡		  : ά
;*
;*---- ͬѺõĽ֮ϣӭϵʽҽ-----------------------------------
;* 
;* Email 	    : wyoujtg@163.com
;* Web 		    :
;*		    
;*****************************************************************************************************
;*/

	#include "Config.h"

	#include <stdarg.h>

/*
;*****************************************************************************************************
;*  : RS232_Init
;*      : ʼRS232
;* 䡡	  : baudrate: 
;*        
;* 䡡	  : TRUE  FALSE
;*****************************************************************************************************
;*/
uint8 RS232_Init(uint32 baudrate)
{  
	// Ƶ : 16.0MHz
	// ͨŲ: 8 Data, 1 Stop, No Parity 
	// :   19200
	 UCSRB = 0x00; //disable while setting baud rate
	 UCSRA = 0x00;
	 UCSRC = 0x06;
	 UBRRL = 0x33; //set baud rate lo
	 UBRRH = 0x00; //set baud rate hi
	 UCSRB = 0x18;

    return TRUE;
}

/*
;*****************************************************************************************************
;*  : RS232_SendByte
;*      : ڷһֽݣȴ
;* 䡡	  : data: Ҫ͵
;*        
;* 䡡	  : 
;*****************************************************************************************************
;*/
void RS232_SendByte(uint8 data)
{  
   	if (data == '\n')
   	{
		data = '\r';				
	}	
	else
	if (data == '\t')
	{		
		data = ' ';
	
		// ǷԷ, UDRE = 1 ĴΪ
		while ( !( UCSRA & (1 << UDRE)) )
			   ;
		UDR = data;
	
		// ǷԷ, UDRE = 1 ĴΪ
		while ( !( UCSRA & (1 << UDRE)) )
			   ;
		UDR = data;
	
	}
	// ǷԷ, UDRE = 1 ĴΪ
    while ( !( UCSRA & (1 << UDRE)) )
           ;
    UDR = data;
}

/*
;*****************************************************************************************************
;*  : RS232_RecvByte
;*      : Ӵڽһֽ
;* 䡡	  : 
;*        
;* 䡡	  : յ
;*****************************************************************************************************
;*/
uint8 RS232_RecvByte(void)
{  
	while (!(UCSRA & (1 << RXC)))
	{
		//OSTimeDly(1);
	}
	
    return UDR;
}

/*
;*****************************************************************************************************
;*  : RS232_SendStr
;*      : ڷһַ
;* 䡡	  : str: Ҫ͵ַ
;*        
;* 䡡	  : 
;*****************************************************************************************************
;*/
void RS232_SendStr(char const *str)
{  
	char ch;

    if ((ch = *str++) != '\0')
    {
        do
        {
            RS232_SendByte(ch); 

        } while((ch = *str++) != '\0');

        RS232_SendByte('\n'); 
    }
}

/*
;*****************************************************************************************************
;*  : RS232_RecvStr
;*      : Ӵڽһַ
;* 䡡	  : str: ַ
;*   
;* 䡡	  :  
;*****************************************************************************************************
;*/
void RS232_RecvStr(char *str)
{
    char ch;
    uint8 i = 0;

	
    if (str != 0)
    { 
        while (1)
        {
            ch = RS232_RecvByte();                           	//  1ַ
            
            if (ch == '\r')                         			//  ջس
            {
                RS232_SendByte(ch);                           	//  Ըַ
                str[i] = '\0';                                  //  ַ־                
                break;
            }
#define BACK_KEY 0x08
			if (ch == BACK_KEY)
#undef  BACK_KEY
			{					
				if (i)
				{
					RS232_SendByte(ch);
					RS232_SendByte(' ');
					RS232_SendByte(ch);	
				}
				i -= i ? 1 : 0;	
			}             
			else                                            	//  յǿɴӡַ
			{
				str[i++] = ch;                                 	//  浽
				RS232_SendByte(ch);                           	//  Ըַ
			}
        }
    } 
}

/*
;*****************************************************************************************************
;*  : RS232_Printf
;*      : ڸʽ
;* 䡡	  : char *fmt, ...
;*        
;* 䡡	  : 
;*****************************************************************************************************
;*/
void RS232_Printf (char *fmt, ...)
{
	va_list ap; 						//
	char strval[6];     
	char *str;
	char *p; 
	int nval; 
    int8 i = 0;

	
	va_start(ap, fmt); 					//õһΪfmt
	
	for(p = fmt; *p; p++) 
	{ 
		if (*p != '%') 
		{
			RS232_SendByte(*p);
			continue; 
		} 
		
		p++; 
		
		switch (*p) 
		{ 
			case 'd': 
				nval = va_arg(ap, int); //ͻȡһ
				i = 0;
				do
				{
					strval[i] = nval % 10;
					nval /= 10;
					i++;
				} while (nval > 0);
				i--;
				break; 
				
			case 'x': 
				nval = va_arg(ap, int); //ͻȡһ
				i = 0;
				do
				{
					strval[i] = nval % 16;
					nval /= 16;
					i++;
				} while (nval > 0);
				i--;
				break; 
				
			case 'c': 
				 i = -1;
				 nval = va_arg(ap, int);							
				 RS232_SendByte(nval);			  
				 break;	
				 
		    case 's':
		    	i = -1;
				str = (char *)va_arg(ap, int);
				do
				{
					nval = *str++;
					if (nval != 0)
					{
						RS232_SendByte(nval);
					}
					else 
					{
						break;
					}
				} while (1);
				break;
				
			default: 
				break;	 
		} 
		
		for(; i >= 0; i--)
		{
			nval = strval[i] + '0';
			RS232_SendByte(nval);
		}
	}
	 
	va_end(ap); 						//ʹ
}


/*
;*****************************************************************************************************
;*                            			End Of File
;*****************************************************************************************************
;*/
